/* xopenfile.c: open a file or exit.

Copyright (C) 1995 Karl Berry.

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#include <kpathsea/config.h>
#include <kpathsea/c-fopen.h>

/* Open NAME for reading and return the resulting file.  If NAME can't
   be opened, exit with an error message including TYPE.  */

FILE *
xopenfile P3C(const_string, name,  const_string, fullname,  const_string, type)
{
  FILE *f = fullname ? fopen (fullname, FOPEN_R_MODE) : NULL;
  if (!f) {
    if (fullname) {
      perror (fullname);
    } else {
      fprintf (stderr, "%s: %s file `%s' not found.\n",
               program_invocation_name, type, name);
    }
    exit (1);
  }
  
  return f;
}
