# common.make -- used by all Makefiles.
SHELL = /bin/sh
@SET_MAKE@
top_srcdir = @top_srcdir@
srcdir = @srcdir@
VPATH = @srcdir@

CC = @CC@
CFLAGS = @CFLAGS@ $(XCFLAGS)
CPPFLAGS = @CPPFLAGS@ $(XCPPFLAGS)

# You can change CPPFLAGS, CFLAGS, or DEFS.
# Don't change ALL_CPPFLAGS.
# prog_cflags is set by subdirectories of web2c.
# shared_cflags is set by kpathsea.
ALL_CPPFLAGS = $(DEFS) -I. -I$(srcdir) -I$(kpathsea_parent) \
  -I$(kpathsea_srcdir_parent) $(prog_cflags) $(shared_cflags) $(CPPFLAGS)
.c.o:
	$(CC) $(ALL_CPPFLAGS) $(CFLAGS) -c $<
.SUFFIXES: .c .o

# Installation.
INSTALL = @INSTALL@
INSTALL_PROGRAM = @INSTALL_PROGRAM@
INSTALL_DATA = @INSTALL_DATA@

# This is used to recursively copy a fonts/ or tex/ directory to
# $(fontdir) or $(texinputdir).
# The first arg is `.', and the second is the target directory.
CP_R = cp -r

# This is so kpathsea will get remade automatically if you change
# something in it and recompile from the package directory.
kpathsea_parent = ..
kpathsea_dir = $(kpathsea_parent)/kpathsea
kpathsea_srcdir_parent = $(top_srcdir)/..
kpathsea_srcdir = $(kpathsea_srcdir_parent)/kpathsea

# This is all so we can get the right name for the kpathsea library so
# we can depend on it.
shared_ext = @sharedlib_extension@
shared_suffix = @sharedlib_suffix@
staticlibname = libkpathsea.a
sharedlibname = libkpathsea.$(shared_ext)$(shared_suffix)
staticlib = $(kpathsea_dir)/$(staticlibname)
sharedlib = $(kpathsea_dir)/$(sharedlibname)
kpathsea = @library_target@

# Sometimes we need to use programs in building other programs.
shared_env = @sharedlib_envvar@=$(kpathsea_dir)

##ifeq ($(CC), gcc)
##XDEFS = -D__USE_FIXED_PROTOTYPES__ -Wall -Wpointer-arith $(warn_more)
##CFLAGS = -g $(XCFLAGS)
##endif
# End of common.make.
