/* usage.c: Output a help message (from help.h).

Copyright (C) 1995 Karl Berry.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "config.h"

/* We're passed in zero for STATUS if this is from --help, else nonzero
   if it was from some kind of error.  In that case, we say `See
   HELP_STR --help for more information.'  */

void
usage P2C(int, status,  const_string, help_str)
{
  if (status == 0) {
    fputs (help_str, stdout);
  } else {
    fprintf (stderr, "Try `%s --help' for more information.\n", help_str);
  }
  uexit (status);
}
